#!/bin/bash
# Copyright (C) 2008 Linagora Group.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

_mysql=`which mysql 2>/dev/null`

if [ -f /etc/obm/obm-rpm.conf ]; then
    obmconf='/etc/obm/obm-rpm.conf'
fi

# Double check if MySQL server is around
rpm -q mysql-server 1>/dev/null 2> /tmp/$1.log && retval=$?
if [ $retval -ne 0 ]; then
    echo -e "ERROR: MySQL server is not installed."
    exit $retval
fi

#echo -e '- Checking\c'
#MYSQL_SQL=`rpm -qa |grep obm-mysql | cut -d"-" -f1-3`
#echo -e "..OK"

. ${obmconf}

DB="MySQL"
# Check if MySQL server is running
if [ -f /etc/init.d/mysqld ]; then
    /sbin/service mysqld status 1>/dev/null 2>/dev/null && retval=$?
else
    echo -e "ERROR: missing files [/etc/init.d/mysqld]"
    echo -e "Database setup abouted."
    exit 1
fi

if [ $retval -gt 0 ] ; then
    /sbin/service mysqld start
fi

echo -e "\n"
echo -e "Enter Mysql Admin Password :\c "
stty -echo
read passwd
stty echo

if [ -z ${passwd} ] ; then
    MYSQL_CMD="$_mysql -h ${OBM_HOST}"
else
    MYSQL_CMD="$_mysql -h ${OBM_HOST} -u root -p$passwd"
fi

# Check if database already exist
CHECKDB=`${MYSQL_CMD} -e "SHOW DATABASES"| grep ${OBM_DBNAME}`
if [ "$CHECKDB" = "${OBM_DBNAME}" ] ; then
	echo "WARNING: DataBase ${OBM_DBNAME} already exist"
	echo -e "o Would you like to override ${OBM_DBNAME} DataBase : (y)es (n)o ?\c "
	read answear
        if [ ${answear} = "y" -o ${answear} = "yes" ] ; then
        	# Drop present database (outch!)
                $MYSQL_CMD -e "DROP DATABASE ${OBM_DBNAME}" && retval=$?
		sleep 1
		echo -e "- Overriding.....\c "
		if [ $retval -eq 0 ] && echo -e "OK"
	else
		echo -e "\n"
		echo "So then, choose another Database name in obm-config before continue."
		exit 0
	fi
fi

# Create DataBase 
echo -e "- Creating OBM DataBase.....\c "
sleep 1
$MYSQL_CMD -e "CREATE DATABASE ${OBM_DBNAME}" && retval=$?
if [ $retval -eq 0 ] && echo -e "OK"

# Add user to DataBase
echo -e "- Adding OBM user.....\c "
sleep 1
$MYSQL_CMD -e "GRANT ALL PRIVILEGES ON ${OBM_DBNAME}.* TO '${OBM_DBUSER}'@'${OBM_HOST}' IDENTIFIED BY '$OBM_PASSWD' WITH GRANT OPTION" && retval=$?
if [ $retval -eq 0 ] && echo -e "OK"
	
echo -e "- Installing SQL schemas.....\c "
sleep 2
$MYSQL_CMD ${OBM_DBNAME} < /usr/share/doc/$MYSQL_SQL/mysql.sql && retval=$?
if [ $retval -eq 0 ] && echo -e "OK"

exit 0

